#ifndef __GPIO_H
#define __GPIO_H
#include "stm32f0xx.h"
#include <stdint.h>

namespace gpio {

	//We do this so we only have one Parameter for the pin
	//With it we lose the ability to configure multiple pins at once, but it is easier to handle (for the user)
	//See c file on how to get the port and the pinNumber
// (The clearing wouldn't be neccessary, as the boundaries are cleared)
#define GPIO_PIN(gpio, pin) (((uint32_t)(gpio) & 0xfffffff0 )| (pin))
	enum pins{
		PA0 = GPIO_PIN(GPIOA_BASE, 0),
		PA1 = GPIO_PIN(GPIOA_BASE, 1),
		PA2 = GPIO_PIN(GPIOA_BASE, 2),
		PA3 = GPIO_PIN(GPIOA_BASE, 3),
		PA4 = GPIO_PIN(GPIOA_BASE, 4),
		PA5 = GPIO_PIN(GPIOA_BASE, 5),
		PA6 = GPIO_PIN(GPIOA_BASE, 6),
		PA7 = GPIO_PIN(GPIOA_BASE, 7),
		PA8 = GPIO_PIN(GPIOA_BASE, 8),
		PA9 = GPIO_PIN(GPIOA_BASE, 9),
		PA10 = GPIO_PIN(GPIOA_BASE, 10),
		PA11 = GPIO_PIN(GPIOA_BASE, 11),
		PA12 = GPIO_PIN(GPIOA_BASE, 12),
		PA13 = GPIO_PIN(GPIOA_BASE, 13),
		PA14 = GPIO_PIN(GPIOA_BASE, 14),
		PA15 = GPIO_PIN(GPIOA_BASE, 15),
		PB0 = GPIO_PIN(GPIOB_BASE, 0),
		PB1 = GPIO_PIN(GPIOB_BASE, 1),
		PB2 = GPIO_PIN(GPIOB_BASE, 2),
		PB3 = GPIO_PIN(GPIOB_BASE, 3),
		PB4 = GPIO_PIN(GPIOB_BASE, 4),
		PB5 = GPIO_PIN(GPIOB_BASE, 5),
		PB6 = GPIO_PIN(GPIOB_BASE, 6),
		PB7 = GPIO_PIN(GPIOB_BASE, 7),
		PB8 = GPIO_PIN(GPIOB_BASE, 8),
		PB9 = GPIO_PIN(GPIOB_BASE, 9),
		PB10 = GPIO_PIN(GPIOB_BASE, 10),
		PB11 = GPIO_PIN(GPIOB_BASE, 11),
		PB12 = GPIO_PIN(GPIOB_BASE, 12),
		PB13 = GPIO_PIN(GPIOB_BASE, 13),
		PB14 = GPIO_PIN(GPIOB_BASE, 14),
		PB15 = GPIO_PIN(GPIOB_BASE, 15),
		PC0 = GPIO_PIN(GPIOC_BASE, 0),
		PC1 = GPIO_PIN(GPIOC_BASE, 1),
		PC2 = GPIO_PIN(GPIOC_BASE, 2),
		PC3 = GPIO_PIN(GPIOC_BASE, 3),
		PC4 = GPIO_PIN(GPIOC_BASE, 4),
		PC5 = GPIO_PIN(GPIOC_BASE, 5),
		PC6 = GPIO_PIN(GPIOC_BASE, 6),
		PC7 = GPIO_PIN(GPIOC_BASE, 7),
		PC8 = GPIO_PIN(GPIOC_BASE, 8),
		PC9 = GPIO_PIN(GPIOC_BASE, 9),
		PC10 = GPIO_PIN(GPIOC_BASE, 10),
		PC11 = GPIO_PIN(GPIOC_BASE, 11),
		PC12 = GPIO_PIN(GPIOC_BASE, 12),
		PC13 = GPIO_PIN(GPIOC_BASE, 13),
		PC14 = GPIO_PIN(GPIOC_BASE, 14),
		PC15 = GPIO_PIN(GPIOC_BASE, 15),
		PD0 = GPIO_PIN(GPIOD_BASE, 0),
		PD1 = GPIO_PIN(GPIOD_BASE, 1),
		PD2 = GPIO_PIN(GPIOD_BASE, 2),
		PD3 = GPIO_PIN(GPIOD_BASE, 3),
		PD4 = GPIO_PIN(GPIOD_BASE, 4),
		PD5 = GPIO_PIN(GPIOD_BASE, 5),
		PD6 = GPIO_PIN(GPIOD_BASE, 6),
		PD7 = GPIO_PIN(GPIOD_BASE, 7),
		PD8 = GPIO_PIN(GPIOD_BASE, 8),
		PD9 = GPIO_PIN(GPIOD_BASE, 9),
		PD10 = GPIO_PIN(GPIOD_BASE, 10),
		PD11 = GPIO_PIN(GPIOD_BASE, 11),
		PD12 = GPIO_PIN(GPIOD_BASE, 12),
		PD13 = GPIO_PIN(GPIOD_BASE, 13),
		PD14 = GPIO_PIN(GPIOD_BASE, 14),
		PD15 = GPIO_PIN(GPIOD_BASE, 15),
		PF0 = GPIO_PIN(GPIOF_BASE, 0),
		PF1 = GPIO_PIN(GPIOF_BASE, 1),
		PF2 = GPIO_PIN(GPIOF_BASE, 2),
		PF3 = GPIO_PIN(GPIOF_BASE, 3),
		PF4 = GPIO_PIN(GPIOF_BASE, 4),
		PF5 = GPIO_PIN(GPIOF_BASE, 5),
		PF6 = GPIO_PIN(GPIOF_BASE, 6),
		PF7 = GPIO_PIN(GPIOF_BASE, 7),
		PF8 = GPIO_PIN(GPIOF_BASE, 8),
		PF9 = GPIO_PIN(GPIOF_BASE, 9),
		PF10 = GPIO_PIN(GPIOF_BASE, 10),
		PF11 = GPIO_PIN(GPIOF_BASE, 11),
		PF12 = GPIO_PIN(GPIOF_BASE, 12),
		PF13 = GPIO_PIN(GPIOF_BASE, 13),
		PF14 = GPIO_PIN(GPIOF_BASE, 14),
		PF15 = GPIO_PIN(GPIOF_BASE, 15),
	};

	enum pinMode {
		input   = 0b000,
		outputPP = 0b001,
		ouputOD = 0b101,
		AFPP    = 0b010,
		AFOD    = 0b110,
		analog  = 0b011,
	};

	enum speed {
		speedLow    = 0b00,
		speedMedium = 0b01,
		speedHigh    = 0b11,
	};

	enum pullDirection {
		nopull = 0b00,
		pullUp = 0b01,
		pullDown = 0b10,
	};

	enum AF {
		AF0 = 0,
		AF1 = 1,
		AF2 = 2,
		AF3 = 3,
		AF4 = 4,
		AF5 = 5,
		AF6 = 6,
		AF7 = 7,
		//Even though the following aren't supported in the stm32f0xx series,
		//they are in higher series and it doesn't do any harm to have them here without using them
		AF8 = 8,
		AF9 = 9,
		AF10 = 10,
		AF11 = 11,
		AF12 = 12,
		AF13 = 13,
		AF14 = 14,
		AF15 = 15,
	};

	struct port
	{
		GPIO_TypeDef *GPIO;
		volatile uint32_t *reg;
		uint32_t bit;
	};

	void mode(pins pin, pinMode selMode = input, pullDirection selPull = nopull, speed selSpeed = speedHigh);
	void high(pins pin);
	void low(pins pin);
	void set(pins pin, bool state);
	void toggle(pins pin);
	uint8_t read(pins pin);
	void af(pins pin, AF selected);
};
#endif
